Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1282)
+++ palm/trunk/SCRIPTS/mrun	(revision 1289)
@@ -4615,7 +4215,8 @@
                 fi
              fi
-          fi
-
-             # APPEND AUF LOKALER MASCHINE
+
+          fi
+
+             # APPEND ON THIS MACHINE
           if [[ "${actionout[$i]}" = "a" ]]
           then
@@ -4630,10 +4231,11 @@
           fi
 
-             # KOPIEREN AUF LOKALER MASCHINE
-             # ES MUSS KOPIERT WERDEN, DA MOVE NICHT UEBER FILESYSTEM HINAUS MOEGLICH
+             # COPY ON THIS MACHINE
+             # COPY HAS TO BE USED, BECAUSE MOVE DOES NOT WORK IF FILE-ORIGIN AND TARGET ARE
+             # ON DIFFERENT FILE-SYSTEMS
           if [[ "${actionout[$i]}" = ""  &&  $files_for_pes = false ]]
           then
 
-                # KOPIEREN AUF EINPROZESSORMASCHINE
+                # COPY IN CASE OF RUNS ON SINGLE CORES
              if [[ "${extout[$i]}" != " "  &&  "${extout[$i]}" != "" ]]
              then
@@ -4674,8 +4276,6 @@
           then
 
-                # DIE DEN PROZESSOREN EINES PARALLELRECHNERS ZUGEHOERIGEN
-                # DATEIEN WERDEN ERST IN EINEM KATALOG GESAMMELT UND DIESER
-                # WIRD DANN KOPIERT
-                # PER MOVE UMBENANNT WERDEN
+                # FILES FROM THE DIFFERENT CORES ARE MOVED WITH ln-COMMAND TO THE PERMANENT DIRECTORY
+                # AS A FIRST STEP, THE PERMANENT DIRECTORY IS CREATED
              printf "\n  >>> OUTPUT: ${localout[$i]}/_....  to  ${pathout[$i]}\n"
 	     if [[ $link_local_output = true ]]
@@ -4690,5 +4290,6 @@
 		 cd $TEMPDIR
 	     fi
-             # If "ln -f" fails of if "$link_local_output = false" do a normal "cp -r"
+
+                # IF "ln -f" HAS FAILED OR IF "$link_local_output = false" DO A NORMAL COPY "cp -r"
 	     if [[ ! -f "${pathout[$i]}/_0000" ]]
              then
@@ -4707,14 +4308,14 @@
        if [[ $transfer_problems = true ]]
        then
-          printf "\n$striche\n  *** OUTPUT-files saved"
+          printf "\n$dashes\n  *** OUTPUT-files saved"
           printf "\n  +++ WARNING: some data transfers failed! \n"
        else
-          printf "\n$striche\n  *** all OUTPUT-files saved \n"
-       fi
-    fi
-
-
-       # EVENTUELL FOLGEJOB STARTEN
-       # DATEI CONTINUE_RUN MUSS VOM BENUTZERPROGRAMM AUS ERZEUGT WERDEN
+          printf "\n$dashes\n  *** all OUTPUT-files saved \n"
+       fi
+    fi
+
+
+       # IF REQUIRED, START A RESTART-JOB
+       # FILE CONTINUE_RUN MUST HAVE BEEN CREATED BY THE EXECUTABLE (PALM)
     if [[ -f CONTINUE_RUN ]]
     then
@@ -4723,9 +4324,8 @@
        then
 
-             # ZUERST IN MRUN-AUFRUF OPTIONEN FUER FORTSETZUNGSLAUF, FUER
-             # STILLES ABARBEITEN (OHNE INTERAKTIVE RUECKFAGEN) UND FUER
-             # BATCH-BETRIEB (NUR WICHTIG, FALLS BATCH AUF LOKALER MASCHINE
-             # DURCHGEFUEHRT WERDEN SOLL) EINFUEGEN, FALLS NICHT BEREITS VOR-
-             # HANDEN
+             # ADD RESTART-OPTIONS TO THE MRUN-CALL (IF THEY ARE NOT USED ALREADY):
+             # -C TELLS MRUN THAT IT IS A RESTART-RUN
+             # -v SILENT MODE WITHOUT INTERACTIVE QUERIES
+             # -n BATCH-MODE (IMPORTANT ONLY IN CASE OF BATCH JOBS ON THE LOCAL MACHINE)
           [[ $(echo $mc | grep -c "\-C") = 0 ]]  &&  mc="$mc -C"
           [[ $(echo $mc | grep -c "\-v") = 0 ]]  &&  mc="$mc -v"
@@ -4737,12 +4337,12 @@
 
 
-             # JOB STARTEN
+             # START THE RESTART-JOB
           printf "\n\n  *** initiating restart-run on \"$return_addres\" using command:\n"
           echo "      $mc"
-          printf "\n$striche\n"
+          printf "\n$dashes\n"
           if [[ $localhost != $fromhost ]]
           then
 
-             if [[ $localhost = lcsgih  ||  $localhost = lccrayb  ||  $localhost = lccrayh  ||  $localhost = nech  ||  $localhost = ibmh  ||  $localhost = ibmkisti  ||  $localhost = ibmku  ||  $localhost = ibms  ||  $localhost = lcflow  ||  $localhost = lckyu* ]]
+             if [[ $localhost = lccrayh  ||  $localhost = nech  ||  $localhost = ibmh  ||  $localhost = ibmkisti  ||  $localhost = ibmku  ||  $localhost = ibms  ||  $localhost = lcflow  ||  $localhost = lckyu* ]]
              then
                 echo "*** ssh will be used to initiate restart-runs!"
@@ -4786,6 +4386,5 @@
              fi
 
-                # WARTEN, DAMIT SICH RESTART JOB IN QUEUE EINREIHEN KANN, BEVOR
-                # DER AKTUELLE JOB ENDET
+                # WAIT TO ALLOW THE RESTART-JOB TO BE QUEUED, BEFORE THE CURRENT JOB IS FINISHED
 	     if [[ $queue = special1q ]]
 	     then
@@ -4797,11 +4396,8 @@
           else
 
-                # BEI RECHNUNGEN AUF LOKALER MASCHINE KANN MRUN DIREKT AUFGE-
-                # RUFEN WERDEN, AUSSER AUF lcfimm
+                # JOBS RUNNING (AND STARTED) ON THE LOCAL MACHINE CAN DIRECTLY CALL MRUN (WITHOUT
+                # USING SSH)
              cd $LOCAL_PWD
-             if [[ $localhost = lcfimm ]]
-             then
-                ssh $SSH_PORTOPT $return_addres -l $return_username "PATH=\$PATH:$LOCAL_MRUN_PATH;export PALM_BIN=$LOCAL_MRUN_PATH;cd $LOCAL_PWD; $mc " 
-             elif [[ $localhost = lckyuh ]]
+             if [[ $localhost = lckyuh ]]
              then
                 printf "\n  +++ WARNING: no restart mechanism available for host \"$localhost\" "
@@ -4809,5 +4405,5 @@
                 printf "\n               \"$mc\" "
              else
-                eval  $mc                # ' MUESSEN AUSGEWERTET WERDEN
+                eval  $mc                # THE ' MUST BE EVALUATED
              fi
              cd -  > /dev/null
@@ -4815,12 +4411,14 @@
           if [[ $localhost = lckyuh ]]
           then
-             printf "\n$striche\n  *** restart-run to be initiated manually\n"
+             printf "\n$dashes\n  *** restart-run to be initiated manually\n"
           else
-             printf "\n$striche\n  *** restart-run initiated \n"
-          fi
-
-
-             # EVENTUELL INPUT-DATEIEN, DIE VON TEMPORAEREM DATENVERZEICHNIS
-             # GEHOLT WORDEN SIND, LOESCHEN
+             printf "\n$dashes\n  *** restart-run initiated \n"
+          fi
+
+
+             # DELETE INPUT-(RESTART)FILES, WHICH HAVE BEEN FETCHED FROM THE TEMPORARY DATA
+             # DIRECTORY, BACAUSE THEY ARE NOT REQUIRED BY THE RESTART-JOB.
+             # THIS IS DONE IN ORDER TO AVOID EXCEEDING DISC QUOTAS OR DISC SPACE (RESTART-FILES
+             # MAY BE VERY HUGE)
           (( i = 0 ))
           while (( i < iin ))
@@ -4843,5 +4441,5 @@
 
     
-       # EVTL. EMAIL-BENACHRICHTIGUNG UEBER ABGESCHLOSSENEN LAUF
+       # SEND EMAIL NOTIFICATION ABOUT THE FINISHED RUN
     if [[ "$email_notification" != "none" ]]
     then
@@ -4866,5 +4464,5 @@
 
 
-       # ALLE ARBEITEN BEENDET. TEMPORAERER KATALOG KANN GELOESCHT WERDEN
+       # ALL ACTIONS FINISHED, TEMPORARY WORKING-DIRECTORY CAN BE DELETED
     cd  $HOME
     [[ $delete_temporary_catalog = true ]]  &&  rm -rf $TEMPDIR
@@ -4873,8 +4471,8 @@
 
 
-       # FALLS AUF REMOTE-MASCHINE GERECHNET WERDEN SOLL, WERDEN JETZT ENTSPRE-
-       # CHENDE AKTIONEN DURCHGEFUEHRT
-
-       # MRUN-BEFEHL FUER REMOTE-MASCHINE ZUSAMMENSTELLEN
+       # PREPARING ACTIONS,
+       # IF A BATCH-JOB IS TO BE GENERATED AND STARTED ON A REMOTE-MACHINE GERECHNET
+
+       # BUILD THE MRUN-COMMAND TO BE CALLED IN THE BATCH-JOB ON THE REMOTE-MACHINE
     mrun_com="$mrun_script_name -a $afname -c $config_file -d $fname -h $host -H $fromhost -m $memory -t $cpumax -q $queue -R $return_addres -U $return_username -u $remote_username"
     [[ "$cpp_opts" != "" ]]       &&  mrun_com=${mrun_com}" -D \"$cpp_opts\""
@@ -4886,5 +4484,4 @@
     [[ $keep_data_from_previous_run = true ]]  &&  mrun_com=${mrun_com}" -k"
     [[ "$additional_conditions" != "" ]]  &&  mrun_com=${mrun_com}" -K \"$additional_conditions\""
-#    [[ "$makefile" != "$source_path/Makefile" ]]  &&  mrun_com=${mrun_com}" -M \"$makefile\""
     [[ "$output_list" != "" ]]    &&  mrun_com=${mrun_com}" -o \"$output_list\""
     [[ "$read_from_config" = false ]]  &&  mrun_com=${mrun_com}" -S"
@@ -4912,5 +4509,5 @@
 
 
-       # create executable for batch job
+       # CREATE EXECUTABLE FOR BATCH JOB
     if [[ $create_executable_for_batch = true  &&  $restart_run != true ]]
     then
@@ -4918,5 +4515,5 @@
        printf "\n  *** creating the executable for batch job\n"
 
-          # method only works for batch jobs on local hosts
+          # METHOD ONLY WORKS FOR BATCH JOBS ON LOCAL HOSTS
        if [[ $host != $localhost ]]
        then
@@ -4951,14 +4548,14 @@
 
 
-       # ZUSAMMENSTELLUNG DES JOBSCRIPTS AUF DATEI jobfile
+       # BUILD THE JOB-SCRIPTS ON FILE jobfile
     jobfile=jobfile.$RANDOM
 
 
-       # TEMPORAERES VERZEICHNIS GENERIEREN UND NACH DORT WECHSELN
+       # CREATE TEMPORARY DIRECTORY AND SWITCH TO IT
     echo  "mkdir  $TEMPDIR"      >>  $jobfile
     echo  "cd  $TEMPDIR"         >>  $jobfile
 
 
-       # EVENTUELL FEHLERVERFOLGUNG AKTIVIEREN
+       # ACTIVATE ERROR-TRACEBACK
     if [[ $do_trace = true ]]
     then
@@ -4969,5 +4566,5 @@
 
 
-       # initialize the environment and load modules
+       # INITIALIZE THE ENVIRONMENT AND LOAD MODULES
     if [[ "$init_cmds" != "" ]]
     then
@@ -4980,11 +4577,15 @@
 
 
-       # BEREITSTELLUNG VON QUELLTEXTEN, MRUN-SCRIPTS UND KONFIGURATIONS-
-       # DATEI FUER DEN JOB
-    if [[ $( echo $host | cut -c1-5 ) = lcsgi  ||  $host = ibmkisti  ||  $host = lccrayb  ||  $host = lccrayf  ||  $host = lccrayh ]]
-    then
-
-          # KONFIGURATIONSDATEI UND MRUN_SCRIPT IN DAS SOURCE-VERZEICHNIS
-          # KOPIEREN
+       # PROVIDE SOURCE-CODE FILES, MRUN-SCRIPT AND CONFIGURATION-FILE FOR THE JOB
+       # then-CLAUSE: FILES ARE COLLECTED IN THE SOURCES_FOR_RUN_... DIRECTORY ON THE LOCAL HOST,
+       #              WHICH IS THEN FETCHED FROM THE BATCH-JOB BY USING cp/scp
+       #              THE SOURCE-CODE FILES ALREADY EXIST IN THIS DIRECTORY
+       # else-CLAUSE: FILE-CONTENTS ARE PUT INTO THE JOB-FILE AS HERE-DOCUMENTS
+       #              THIS MAY CREATE A QUITE LARGE JOB-FILE, WHICH CAN CAUSE PROBLEMS WITH SOME
+       #              QUEUEING-SYSTEMS
+    if [[ $host = ibmkisti  ||  $host = lccrayb  ||  $host = lccrayf  ||  $host = lccrayh ]]
+    then
+
+          # COPY CONFIGURATION-FILE AND MRUN-SCRIPT INTO THE SOURCES_FOR_RUN... DIRECTORY
        if [[ $restart_run != true ]]
        then
@@ -4993,6 +4594,6 @@
        fi
 
-          # SOURCE-VERZEICHNIS VOM LOKALEN RECHNER PER SCP TRANSFERIEREN
-          # (BEI JOBS AUF LOKALEM RECHNER REICHT CP)
+          # COPY THE SOURCES_FOR_RUN... DIRECTORY FROM THE LOCAL HOST TO THE JOB VIA scp
+          # (then-CLAUSE: JOBS ON THE LOCAL HOST CAN JUST USE cp)
        echo  "set -x"  >>  $jobfile
        if [[ $host = $localhost ]]
@@ -5011,5 +4612,5 @@
           if [[ $host = ibmkisti ]]
           then
-                # on KISTI's IBM firewall is only opened on interactive node
+                # ON KISTI'S IBM FIREWALL IS ONLY OPENED ON INTERACTIVE NODE
              echo  "localdir=\`pwd\`"                            >>  $jobfile
              echo  "ssh $SSH_PORTOPT $remote_username@gaiad \"cd \$localdir; scp $PORTOPT -r  $return_username@$return_addres:$working_directory/SOURCES_FOR_RUN_$fname .\" "  >>  $jobfile
@@ -5029,6 +4630,6 @@
        echo  "export SOURCES_COMPLETE=true"                      >>  $jobfile
 
-          # QUELLTEXTE, MRUN-SCRIPT UND KONFIGURATIONSDATEI IN DAS AKTUELLE
-          # ARBEITSVERZEICHNIS VERSCHIEBEN
+          # MOVE MRUN-SCRIPT AND CONFIGURATION-FILE FROM THE SOURCES_FOR_RUN... DIRECTORY TO THE
+          # WORKING DIRECTORY OF THE JOB
        echo  "mv  SOURCES_FOR_RUN_$fname/$config_file  . "       >>  $jobfile
        echo  "mv  SOURCES_FOR_RUN_$fname/$mrun_script_name  . "  >>  $jobfile
@@ -5039,6 +4640,5 @@
     else
 
-          # ABSPEICHERN DER QUELLTEXTE (NUR FALLS UEBERSETZT WERDEN SOLL)
-          # SOWIE GEGEBENENFALLS DES MAKEFILES
+          # PROVIDE SOURCE-CODE FILES AND MAKEFILE AS HERE DOCUMENT
        if [[ $do_compile = true ]]
        then
@@ -5046,7 +4646,5 @@
           source_catalog=SOURCES_FOR_RUN_$fname
 
-              # UNTERVERZEICHNIS FUER QUELLTEXTE UND MAKEFILE ANLEGEN
-              # MRUN WIRD DIESES VRZEICHNIS UEBER ENVIRONMENT VARIABLE
-              # MITGETEILT (UEBERSTEUERT ANGABE IN KONFIGURATIONSDATEI)
+              # CREATE SOURCES_FOR_RUN... DIRECTORY TO STORE THE SOURCE CODE FILES AND THE MAKEFILE
           echo  "mkdir  SOURCES_FOR_RUN_$fname"                >>  $jobfile
           echo  "export SOURCES_COMPLETE=true"                 >>  $jobfile
@@ -5055,5 +4653,5 @@
           for  filename  in  $source_list
           do
-                # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
+                # BACKSLASH IS USED FOR MASKING
              echo  "cat > $filename << \"%END%\""              >>  $jobfile
              cat   $source_catalog/$filename                   >>  $jobfile
@@ -5063,5 +4661,5 @@
           done
 
-             # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
+             # BACKSLASH IS USED FOR MASKING
           echo  "cat > Makefile << \"%END%\""               >>  $jobfile
           cat   $source_catalog/Makefile                    >>  $jobfile
@@ -5075,13 +4673,12 @@
 
 
-          # ABSPEICHERN DER KONFIGURATIONSDATEI
-          # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
-          # Lines with #$ coming from the svn keyword substitution are
-          # removed from the config file in order to avoid problems
-          # with the SGE batch system
+          # PROVIDE THE CONFIGURATION-FILE AS HERE-DOCUMENT
+          # BACKSLASH IS USED FOR MASKING
+          # LINES WITH #$ IN THE CONFIGURATION-FILE, COMING FROM THE SVN KEYWORD SUBSTITUTION,
+          # ARE REMOVED FROM THE FILE IN ORDER TO AVOID PROBLEMS WITH THE SGE BATCH SYSTEM
        echo  "cat > $config_file << \"%END%\""      >>  $jobfile
        if [[ $host = lckyuh ]]
        then
-             # no cross compiler on compute node
+             # NO CROSS-COMPILER ON COMPUTE NODE
           sed  's/frtpx/frt/g'  $config_file        >>  $jobfile
        else
@@ -5092,6 +4689,6 @@
 
 
-          # ABSPEICHERN DER AKTUELLEN MRUN-VERSION
-          # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
+          # PROVIDE THE MRUN-SCRIPTS AS HERE-DOCUMENT
+          # BACKSLASH IS USED FOR MASKING
        echo  "cat > $mrun_script_name <<\"%END%\""  >>  $jobfile
        if [[ $host = lckyuh ]]
@@ -5109,8 +4706,7 @@
 
 
-       # EVTL. BENOETIGTE INPUT-DATEIEN PER FTP HOLEN ODER DEM JOB DIREKT
-       # MITGEBEN UND AUF DEM REMOTE-RECHNER IM BENUTZERVERZEICHNIS ABLEGEN
-       # FALLS DIESES NICHT EXISTIERT, WIRD VERSUCHT, DAS JEWEILS LETZTE
-       # UNTERVERZEICHNIS DES PFADNAMENS ANZULEGEN
+       # GET REQUIRED INPUT-FILES BY SCP OR BY SENDING THEM WITH THE JOB AS HERE-DOCUMENT
+       # PUT THESE FILES INTO THE USER'S RESPECTIVE PERMANENT DIRECTORIES ON THE REMOTE-HOST
+       # IF THE DIRECTORIES DO NOT EXIST, TRY TO CREATE THEM
     if [[ $do_remote = true ]]
     then
@@ -5130,5 +4726,5 @@
           fi
 
-             # UEBERPRUEFEN, OB DATEI ANGELEGT WERDEN KONNTE
+             # CHECK, IF FILE COULD BE CREATED
           echo  "if [[ \$? = 1 ]]"                    >>  $jobfile
           echo  "then"                                >>  $jobfile
@@ -5142,18 +4738,16 @@
     fi
 
-       # ARBEITSKATALOG AUF DER LOKALEN MASCHINE FUER EVENTUELLE 
-       # FORTSETZUNGSLAUEFE PER ENV-VARIABLE UEBERGEBEN
+       # PROVIDE NAME OF THE CURRENT WORKING-DIRECTORY ON THE LOCAL MACHINE (FROM WHERE THE JOB IS
+       # STARTED) BY SETTING AN ENVIRONMENT-VARIABLE. THIS INFORMATION IS USED IN THE JOB BY MRUN
+       # IN CASE THAT RESTART-RUNS HAVE TO BE GENERATED
     echo  "LOCAL_PWD=$working_directory"                >>  $jobfile
     echo  "export LOCAL_PWD"                            >>  $jobfile
 
-       # EBENSO LOKALEN MRUN-KATALOG UEBERGEBEN 
+       # PROVIDE THE PATH OF THE LOCAL MRUN-SCRIPT FOR THE SAME REASON 
     echo  "LOCAL_MRUN_PATH=$PALM_BIN"                   >>  $jobfile
     echo  "export LOCAL_MRUN_PATH"                      >>  $jobfile
 
-       # WORKAROUND FUER RIAM-NEC-JOBS WEGEN PROFILE-SCHWIERIGKEITEN
-    if [[ $localhost_realname = "gate"  ||  $localhost = lctit ]]
-    then
-       echo  "export PALM_BIN=$PALM_BIN"                >>  $jobfile
-    elif [[ $host = lcflow  ||  $localhost = lcflow ]]
+       # lcflow ALSO REQUIRES TO PROVIDE PATH FOR THE PALM-SCRIPTS
+    if [[ $host = lcflow  ||  $localhost = lcflow ]]
     then
        echo  "export PALM_BIN=$PALM_BIN" | sed -e 's:'$HOME':$HOME:'   >>  $jobfile
@@ -5161,5 +4755,6 @@
     fi
 
-       # MRUN AUF ZIELRECHNER AUFRUFEN (queue is workaround for ibmkisti)
+       # CALL MRUN WITHIN THE JOB (SETTING QUEUE IS A WORKAROUND FOR ibmkisti)
+       # AS FINAL ACTION, REMOVE THE TEMPORARY DIRECTORY CREATED AT THE BEGINNING OF THE JOB
     echo  "set -x"                                        >>  $jobfile
     echo  "queue=$queue"                                  >>  $jobfile
@@ -5172,5 +4767,5 @@
 
 
-       # JOB PER SUBJOB STARTEN
+       # START THE JOB USING SUBJOB-COMMAND
     if [[ $silent = false ]]
     then
@@ -5184,7 +4779,3 @@
 
 
- fi  # ENDE REMOTE-TEIL
-
-
-
-     # ENDE DER PROZEDUR
+ fi  # END OF REMOTE-PART
